#include <stdio.h>
#include <sys/time.h>

int
main()
{
	struct timeval prevtime;
	struct timeval curtime;

	gettimeofday(&prevtime, NULL);

	for (;;)
	{
		gettimeofday(&curtime, NULL);

		if (curtime.tv_usec < 0 || curtime.tv_usec >= 1000000)
			fprintf(stderr, "bogus tv_usec: %ld %ld, prev %ld %ld\n",
					(long int) curtime.tv_sec,
					(long int) curtime.tv_usec,
					(long int) prevtime.tv_sec,
					(long int) prevtime.tv_usec);

		if (curtime.tv_sec < prevtime.tv_sec ||
			curtime.tv_sec > prevtime.tv_sec + 1)
			fprintf(stderr, "out of order tv_sec: %ld %ld, prev %ld %ld\n",
					(long int) curtime.tv_sec,
					(long int) curtime.tv_usec,
					(long int) prevtime.tv_sec,
					(long int) prevtime.tv_usec);

		if (curtime.tv_usec < prevtime.tv_usec &&
			curtime.tv_sec != prevtime.tv_sec + 1)
			fprintf(stderr, "out of order tv_usec: %ld %ld, prev %ld %ld\n",
					(long int) curtime.tv_sec,
					(long int) curtime.tv_usec,
					(long int) prevtime.tv_sec,
					(long int) prevtime.tv_usec);

		prevtime = curtime;
	}

	return 0;
}
